/**
 * Title:	Traces
 * Copyright:	Copyright (c) Jan-Pascal van Best
 * Email:	    janpascal@vanbest.org
 * @author	    Jan-Pascal van Best
 **************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, version 2.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package nl.tudelft.tbm.matrix;


import java.util.*;
import java.io.*;
import java.lang.*;

public interface Matrix {
    int getRows();
    int getColumns();

	double get(int i, int j);
	void set(int i, int j, double value);

	Matrix transpose();
    Matrix inverse();

	// matrix algebra
	Matrix times(Matrix other);
	Matrix times(double other);
	Matrix plus(Matrix other);
	Matrix minus(Matrix other);

	// elementary operations
	void swapRow(int r1, int r2);
	void scaleRow(int row, double factor);
	// r1 := r1 + factor * r2
	void addRow(int r1, int r2, double factor);

	//
    int rank();
    String toString(int width, int decimals);
    void print (int w, int d);
}

